diff -Nru dovecot-2.2.36.1/src/lib-storage/index/index-pop3-uidl.c dovecot-2.2.36.3/src/lib-storage/index/index-pop3-uidl.c
--- dovecot-2.2.36.1/src/lib-storage/index/index-pop3-uidl.c	2019-01-23 11:05:15.000000000 +0100
+++ dovecot-2.2.36.3/src/lib-storage/index/index-pop3-uidl.c	2019-03-18 13:07:31.000000000 +0100
@@ -37,7 +37,7 @@
 		/* this header isn't set yet */
 		return TRUE;
 	}
-	memcpy(&uidl, data, size);
+	memcpy(&uidl, data, sizeof(uidl));
 	return mail->uid <= uidl.max_uid_with_pop3_uidl;
 }
 
@@ -95,7 +95,7 @@
 
 	/* check if we have already the same header */
 	if (size >= sizeof(uidl)) {
-		memcpy(&uidl, data, size);
+		memcpy(&uidl, data, sizeof(uidl));
 		if (trans->highest_pop3_uidl_uid == uidl.max_uid_with_pop3_uidl)
 			return;
 	}
diff -Nru dovecot-2.2.36.1/src/plugins/fts/fts-api.c dovecot-2.2.36.3/src/plugins/fts/fts-api.c
--- dovecot-2.2.36.1/src/plugins/fts/fts-api.c	2019-01-23 11:05:15.000000000 +0100
+++ dovecot-2.2.36.3/src/plugins/fts/fts-api.c	2019-03-18 13:07:31.000000000 +0100
@@ -425,7 +425,7 @@
 		i_zero(hdr_r);
 		ret = FALSE;
 	} else {
-		memcpy(hdr_r, data, data_size);
+		memcpy(hdr_r, data, sizeof(*hdr_r));
 		ret = TRUE;
 	}
 	mail_index_view_close(&view);
